<?php
/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package clothing_marketplace
 */

function clothing_marketplace_body_classes( $clothing_marketplace_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$clothing_marketplace_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$clothing_marketplace_classes[] = 'no-sidebar';
	}

	$clothing_marketplace_classes[] = clothing_marketplace_sidebar_layout();

	return $clothing_marketplace_classes;
}
add_filter( 'body_class', 'clothing_marketplace_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function clothing_marketplace_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'clothing_marketplace_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function clothing_marketplace_get_post_choices() {
	$clothing_marketplace_choices = array( '' => esc_html__( '--Select--', 'clothing-marketplace' ) );
	$clothing_marketplace_args    = array( 'numberposts' => -1 );
	$clothing_marketplace_posts   = get_posts( $clothing_marketplace_args );

	foreach ( $clothing_marketplace_posts as $clothing_marketplace_post ) {
		$clothing_marketplace_id             = $clothing_marketplace_post->ID;
		$clothing_marketplace_title          = $clothing_marketplace_post->post_title;
		$clothing_marketplace_choices[ $clothing_marketplace_id ] = $clothing_marketplace_title;
	}

	return $clothing_marketplace_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function clothing_marketplace_get_page_choices() {
	$clothing_marketplace_choices = array( '' => esc_html__( '--Select--', 'clothing-marketplace' ) );
	$clothing_marketplace_pages   = get_pages();

	foreach ( $clothing_marketplace_pages as $clothing_marketplace_page ) {
		$clothing_marketplace_choices[ $clothing_marketplace_page->ID ] = $clothing_marketplace_page->post_title;
	}

	return $clothing_marketplace_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function clothing_marketplace_get_post_cat_choices() {
	$clothing_marketplace_choices = array( '' => esc_html__( '--Select--', 'clothing-marketplace' ) );
	$clothing_marketplace_cats    = get_categories();

	foreach ( $clothing_marketplace_cats as $clothing_marketplace_cat ) {
		$clothing_marketplace_choices[ $clothing_marketplace_cat->term_id ] = $clothing_marketplace_cat->name;
	}

	return $clothing_marketplace_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function clothing_marketplace_get_post_donation_form_choices() {
	$clothing_marketplace_choices = array( '' => esc_html__( '--Select--', 'clothing-marketplace' ) );
	$clothing_marketplace_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $clothing_marketplace_posts as $clothing_marketplace_post ) {
		$clothing_marketplace_choices[ $clothing_marketplace_post->ID ] = $clothing_marketplace_post->post_title;
	}
	return $clothing_marketplace_choices;
}

if ( ! function_exists( 'clothing_marketplace_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function clothing_marketplace_excerpt_length( $clothing_marketplace_length ) {
		if ( is_admin() ) {
			return $clothing_marketplace_length;
		}

		return get_theme_mod( 'clothing_marketplace_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'clothing_marketplace_excerpt_length', 999 );

if ( ! function_exists( 'clothing_marketplace_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function clothing_marketplace_excerpt_more( $clothing_marketplace_more ) {
		if ( is_admin() ) {
			return $clothing_marketplace_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'clothing_marketplace_excerpt_more' );

if ( ! function_exists( 'clothing_marketplace_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function clothing_marketplace_sidebar_layout() {
		$clothing_marketplace_sidebar_position      = get_theme_mod( 'clothing_marketplace_sidebar_position', 'right-sidebar' );
		$clothing_marketplace_sidebar_position_post = get_theme_mod( 'clothing_marketplace_post_sidebar_position', 'right-sidebar' );
		$clothing_marketplace_sidebar_position_page = get_theme_mod( 'clothing_marketplace_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$clothing_marketplace_sidebar_position = $clothing_marketplace_sidebar_position_post;
		} elseif ( is_page() ) {
			$clothing_marketplace_sidebar_position = $clothing_marketplace_sidebar_position_page;
		}

		return $clothing_marketplace_sidebar_position;
	}
}

if ( ! function_exists( 'clothing_marketplace_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function clothing_marketplace_is_sidebar_enabled() {
		$clothing_marketplace_sidebar_position      = get_theme_mod( 'clothing_marketplace_sidebar_position', 'right-sidebar' );
		$clothing_marketplace_sidebar_position_post = get_theme_mod( 'clothing_marketplace_post_sidebar_position', 'right-sidebar' );
		$clothing_marketplace_sidebar_position_page = get_theme_mod( 'clothing_marketplace_page_sidebar_position', 'right-sidebar' );

		$clothing_marketplace_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $clothing_marketplace_sidebar_position ) {
				$clothing_marketplace_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $clothing_marketplace_sidebar_position || 'no-sidebar' === $clothing_marketplace_sidebar_position_post ) {
				$clothing_marketplace_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $clothing_marketplace_sidebar_position || 'no-sidebar' === $clothing_marketplace_sidebar_position_page ) {
				$clothing_marketplace_sidebar_enabled = false;
			}
		}
		return $clothing_marketplace_sidebar_enabled;
	}
}

if ( ! function_exists( 'clothing_marketplace_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function clothing_marketplace_get_homepage_sections() {
		$clothing_marketplace_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'clothing-marketplace' ),
			'services' => esc_html__( 'Services Section', 'clothing-marketplace' ),
		);
		return $clothing_marketplace_sections;
	}
}

/**
 * Renders customizer section link
 */
function clothing_marketplace_section_link( $clothing_marketplace_section_id ) {
	$clothing_marketplace_section_name      = str_replace( 'clothing_marketplace_', ' ', $clothing_marketplace_section_id );
	$clothing_marketplace_section_name      = str_replace( '_', ' ', $clothing_marketplace_section_name );
	$clothing_marketplace_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $clothing_marketplace_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $clothing_marketplace_starting_notation . $clothing_marketplace_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function clothing_marketplace_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'clothing_marketplace_section_link_css' );

/**
 * Breadcrumb.
 */
function clothing_marketplace_breadcrumb( $clothing_marketplace_args = array() ) {
	if ( ! get_theme_mod( 'clothing_marketplace_enable_breadcrumb', true ) ) {
		return;
	}

	$clothing_marketplace_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $clothing_marketplace_args );
}
add_action( 'clothing_marketplace_breadcrumb', 'clothing_marketplace_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function clothing_marketplace_breadcrumb_trail_print_styles() {
	$clothing_marketplace_breadcrumb_separator = get_theme_mod( 'clothing_marketplace_breadcrumb_separator', '/' );

	$clothing_marketplace_style = '
		.trail-items li::after {
			content: "' . $clothing_marketplace_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$clothing_marketplace_style = apply_filters( 'clothing_marketplace_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $clothing_marketplace_style ) ) );

	if ( $clothing_marketplace_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $clothing_marketplace_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'clothing_marketplace_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function clothing_marketplace_render_posts_pagination() {
	$clothing_marketplace_is_pagination_enabled = get_theme_mod( 'clothing_marketplace_enable_pagination', true );
	if ( $clothing_marketplace_is_pagination_enabled ) {
		$clothing_marketplace_pagination_type = get_theme_mod( 'clothing_marketplace_pagination_type', 'default' );
		if ( 'default' === $clothing_marketplace_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'clothing_marketplace_posts_pagination', 'clothing_marketplace_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function clothing_marketplace_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'clothing_marketplace_post_navigation', 'clothing_marketplace_render_post_navigation' );

/**
 * Adds footer copyright text.
 */
function clothing_marketplace_output_footer_copyright_content() {
    $clothing_marketplace_theme_data = wp_get_theme();
    $clothing_marketplace_copyright_text = get_theme_mod('clothing_marketplace_footer_copyright_text');

	if (!empty($clothing_marketplace_copyright_text)) {
        $clothing_marketplace_text = $clothing_marketplace_copyright_text;
    } else {

		$clothing_marketplace_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/clothing-marketplace','clothing-marketplace')) . '" target="_blank"> ' . esc_html($clothing_marketplace_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'clothing-marketplace') . '&nbsp;<a target="_blank" href="' . esc_url($clothing_marketplace_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($clothing_marketplace_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $clothing_marketplace_default_text .= sprintf(esc_html__(' | Powered by %s', 'clothing-marketplace'), '<a href="' . esc_url(__('https://wordpress.org/', 'clothing-marketplace')) . '" target="_blank">WordPress</a>. ');

        $clothing_marketplace_text = $clothing_marketplace_default_text;

    }
    ?>
    <span><?php echo wp_kses_post($clothing_marketplace_text); ?></span>
    <?php
}
add_action('clothing_marketplace_footer_copyright', 'clothing_marketplace_output_footer_copyright_content');

/* Footer Social Icons */ 
function clothing_marketplace_footer_social_links() {

    if ( get_theme_mod('clothing_marketplace_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('clothing_marketplace_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('clothing_marketplace_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('clothing_marketplace_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'clothing-marketplace'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('clothing_marketplace_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('clothing_marketplace_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('clothing_marketplace_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'clothing-marketplace'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('clothing_marketplace_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('clothing_marketplace_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('clothing_marketplace_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'clothing-marketplace'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('clothing_marketplace_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('clothing_marketplace_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('clothing_marketplace_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'clothing-marketplace'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('clothing_marketplace_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('clothing_marketplace_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('clothing_marketplace_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'clothing-marketplace'); ?></span>
						</a>
					<?php } ?>
				</div>
            </div>
            <?php
    }
}
add_action('wp_footer', 'clothing_marketplace_footer_social_links');

if ( ! function_exists( 'clothing_marketplace_footer_widget' ) ) :
	function clothing_marketplace_footer_widget() {
		$clothing_marketplace_footer_widget_column = get_theme_mod('clothing_marketplace_footer_widget_column','4');

		$clothing_marketplace_column_class = '';
		if ($clothing_marketplace_footer_widget_column == '1') {
			$clothing_marketplace_column_class = 'one-column';
		} elseif ($clothing_marketplace_footer_widget_column == '2') {
			$clothing_marketplace_column_class = 'two-columns';
		} elseif ($clothing_marketplace_footer_widget_column == '3') {
			$clothing_marketplace_column_class = 'three-columns';
		} else {
			$clothing_marketplace_column_class = 'four-columns';
		}
	
		if($clothing_marketplace_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($clothing_marketplace_column_class); ?>">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($clothing_marketplace_i = 1; $clothing_marketplace_i <= $clothing_marketplace_footer_widget_column; $clothing_marketplace_i++) {
					if (is_active_sidebar('footer-widget-' . $clothing_marketplace_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($clothing_marketplace_i = 1; $clothing_marketplace_i <= $clothing_marketplace_footer_widget_column; $clothing_marketplace_i++) {
						if (is_active_sidebar('footer-widget-' . $clothing_marketplace_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('footer-widget-' . $clothing_marketplace_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'clothing-marketplace'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'clothing-marketplace'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'clothing-marketplace'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'clothing-marketplace'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="categories" class="widget py-3" role="complementary" aria-label="<?php esc_attr_e('footer1', 'clothing-marketplace'); ?>">
                        <h3 class="widget-title"><?php esc_html_e('Categories', 'clothing-marketplace'); ?></h3>
                        <ul>
                            <?php wp_list_categories(array(
                                'title_li' => '',
                                'number'   => 5
                            )); ?>
                        </ul>
                    </aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'clothing_marketplace_footer_widget', 'clothing_marketplace_footer_widget' );


function clothing_marketplace_footer_text_transform_css() {
    $clothing_marketplace_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($clothing_marketplace_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'clothing_marketplace_footer_text_transform_css');

/**
 * GET START FUNCTION
 */

 function clothing_marketplace_getpage_css($hook) {
	wp_enqueue_script( 'clothing-marketplace-admin-script', get_template_directory_uri() . '/resource/js/clothing-marketplace-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'clothing-marketplace-admin-script', 'clothing_marketplace_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'clothing-marketplace-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'clothing_marketplace_getpage_css' );

add_action('wp_ajax_clothing_marketplace_dismissable_notice', 'clothing_marketplace_dismissable_notice');
function clothing_marketplace_switch_theme() {
    delete_user_meta(get_current_user_id(), 'clothing_marketplace_dismissable_notice');
}
add_action('after_switch_theme', 'clothing_marketplace_switch_theme');
function clothing_marketplace_dismissable_notice() {
    update_user_meta(get_current_user_id(), 'clothing_marketplace_dismissable_notice', true);
    die();
}

function clothing_marketplace_deprecated_hook_admin_notice() {
    global $pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'clothing-marketplace-getting-started' ) {
        return;
    }

    $dismissed = get_user_meta( get_current_user_id(), 'clothing_marketplace_dismissable_notice', true );
    if ( !$dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Clothing Marketplace', 'clothing-marketplace'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Clothing Marketplace journey to the next level.', 'clothing-marketplace'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'clothing-marketplace'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=clothing-marketplace-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'clothing-marketplace' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( CLOTHING_MARKETPLACE_PRO_DEMO ); ?>"><?php esc_html_e('View Demo', 'clothing-marketplace') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( CLOTHING_MARKETPLACE_PREMIUM_PAGE ); ?>"><?php esc_html_e('Buy Now', 'clothing-marketplace') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( CLOTHING_MARKETPLACE_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'clothing-marketplace') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}
add_action( 'admin_notices', 'clothing_marketplace_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function clothing_marketplace_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}